/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Diff of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.12 Revision 1.68
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.12 2004/12/28 20:05:45 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.68 2009/09/06 23:36:04 robbat2 Exp $
4# 4#
5# Description: This eclass is used as a central eclass for accessing kernel
6# related information for sources already installed.
7# It is vital for linux-mod to function correctly, and is split
8# out so that any ebuild behaviour "templates" are abstracted out
9# using additional eclasses.
10#
11# Maintainer: John Mylchreest <johnm@gentoo.org> 5# Original author: John Mylchreest <johnm@gentoo.org>
12# Copyright 2004 Gentoo Linux 6# Maintainer: kernel-misc@gentoo.org
13# 7#
14# Please direct your bugs to the current eclass maintainer :) 8# Please direct your bugs to the current eclass maintainer :)
9
10# @ECLASS: linux-info.eclass
11# @MAINTAINER:
12# kernel-misc@gentoo.org
13# @BLURB: eclass used for accessing kernel related information
14# @DESCRIPTION:
15# This eclass is used as a central eclass for accessing kernel
16# related information for source or binary already installed.
17# It is vital for linux-mod.eclass to function correctly, and is split
18# out so that any ebuild behaviour "templates" are abstracted out
19# using additional eclasses.
20#
21# "kernel config" in this file means:
22# The .config of the currently installed sources is used as the first
23# preference, with a fall-back to bundled config (/proc/config.gz) if available.
15 24
16# A Couple of env vars are available to effect usage of this eclass 25# A Couple of env vars are available to effect usage of this eclass
17# These are as follows: 26# These are as follows:
18# 27
19# Env Var Option Description 28# @ECLASS-VARIABLE: KERNEL_DIR
20# KERNEL_DIR <string> The directory containing kernel the target kernel 29# @DESCRIPTION:
21# sources. 30# A string containing the directory of the target kernel sources. The default value is
31# "/usr/src/linux"
32
33# @ECLASS-VARIABLE: CONFIG_CHECK
34# @DESCRIPTION:
22# CONFIG_CHECK <string> a list of .config options to check for before 35# A string containing a list of .config options to check for before
23# proceeding with the install. ie: CONFIG_CHECK="MTRR" 36# proceeding with the install.
37#
38# e.g.: CONFIG_CHECK="MTRR"
39#
24# You can also check that an option doesn't exist by 40# You can also check that an option doesn't exist by
25# prepending it with an exclamation mark (!). 41# prepending it with an exclamation mark (!).
42#
26# ie: CONFIG_CHECK="!MTRR" 43# e.g.: CONFIG_CHECK="!MTRR"
27# <CFG>_ERROR <string> The error message to display when the above check 44#
45# To simply warn about a missing option, prepend a '~'.
46# It may be combined with '!'.
47#
48# In general, most checks should be non-fatal. The only time fatal checks should
49# be used is for building kernel modules or cases that a compile will fail
50# without the option.
51#
52# This is to allow usage of binary kernels, and minimal systems without kernel
53# sources.
54
55# @ECLASS-VARIABLE: ERROR_<CFG>
56# @DESCRIPTION:
57# A string containing the error message to display when the check against CONFIG_CHECK
28# fails. <CFG> should reference the appropriate option 58# fails. <CFG> should reference the appropriate option used in CONFIG_CHECK.
29# as above. ie: MTRR_ERROR="MTRR exists in the .config 59#
30# but shouldn't!!" 60# e.g.: ERROR_MTRR="MTRR exists in the .config but shouldn't!!"
31# KBUILD_OUTPUT <string> This is passed on commandline, or can be set from 61
32# the kernel makefile. This contains the directory 62# @ECLASS-VARIABLE: KBUILD_OUTPUT
63# @DESCRIPTION:
64# A string passed on commandline, or set from the kernel makefile. It contains the directory
33# which is to be used as the kernel object directory. 65# which is to be used as the kernel object directory.
34 66
35# There are also a couple of variables which are set by this, and shouldn't be 67# There are also a couple of variables which are set by this, and shouldn't be
36# set by hand. These are as follows: 68# set by hand. These are as follows:
37# 69
38# Env Var Option Description 70# @ECLASS-VARIABLE: KV_FULL
39# KV_FULL <string> The full kernel version. ie: 2.6.9-gentoo-johnm-r1 71# @DESCRIPTION:
40# KV_MAJOR <integer> The kernel major version. ie: 2 72# A read-only variable. It's a string containing the full kernel version. ie: 2.6.9-gentoo-johnm-r1
41# KV_MINOR <integer> The kernel minor version. ie: 6 73
42# KV_PATCH <integer> The kernel patch version. ie: 9 74# @ECLASS-VARIABLE: KV_MAJOR
43# KV_EXTRA <string> The kernel EXTRAVERSION. ie: -gentoo 75# @DESCRIPTION:
44# KV_LOCAL <string> The kernel LOCALVERSION concatenation. ie: -johnm 76# A read-only variable. It's an integer containing the kernel major version. ie: 2
45# KV_DIR <string> The kernel source directory, will be null if 77
78# @ECLASS-VARIABLE: KV_MINOR
79# @DESCRIPTION:
80# A read-only variable. It's an integer containing the kernel minor version. ie: 6
81
82# @ECLASS-VARIABLE: KV_PATCH
83# @DESCRIPTION:
84# A read-only variable. It's an integer containing the kernel patch version. ie: 9
85
86# @ECLASS-VARIABLE: KV_EXTRA
87# @DESCRIPTION:
88# A read-only variable. It's a string containing the kernel EXTRAVERSION. ie: -gentoo
89
90# @ECLASS-VARIABLE: KV_LOCAL
91# @DESCRIPTION:
92# A read-only variable. It's a string containing the kernel LOCALVERSION concatenation. ie: -johnm
93
94# @ECLASS-VARIABLE: KV_DIR
95# @DESCRIPTION:
96# A read-only variable. It's a string containing the kernel source directory, will be null if
46# KERNEL_DIR is invalid. 97# KERNEL_DIR is invalid.
47# KV_OUT_DIR <string> The kernel object directory. will be KV_DIR unless
48# koutput is used. This should be used for referencing
49# .config.
50 98
99# @ECLASS-VARIABLE: KV_OUT_DIR
100# @DESCRIPTION:
101# A read-only variable. It's a string containing the kernel object directory, will be KV_DIR unless
102# KBUILD_OUTPUT is used. This should be used for referencing .config.
51 103
52ECLASS=linux-info 104# @ECLASS-VARIABLE: I_KNOW_WHAT_I_AM_DOING
53INHERITED="$INHERITED $ECLASS" 105# @DESCRIPTION:
106# Temporary variable for the migration to making linux-info non-fatal.
107
108# And to ensure all the weirdness with crosscompile
109inherit toolchain-funcs versionator
110
54EXPORT_FUNCTIONS pkg_setup 111EXPORT_FUNCTIONS pkg_setup
112
113DEPEND=""
114RDEPEND=""
115
116[ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && \
117DEPEND="kernel_linux? ( virtual/linux-sources )"
55 118
56# Overwritable environment Var's 119# Overwritable environment Var's
57# --------------------------------------- 120# ---------------------------------------
58KERNEL_DIR="${KERNEL_DIR:-/usr/src/linux}" 121KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}"
59 122
60 123
61# Pulled from eutils as it might be more useful only being here since 124# Bug fixes
62# very few ebuilds which dont use this eclass will ever ever use these functions 125# fix to bug #75034
63set_arch_to_kernel() {
64 export PORTAGE_ARCH="${ARCH}"
65 case ${ARCH} in 126case ${ARCH} in
66 x86) export ARCH="i386";; 127 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
67 amd64) export ARCH="x86_64";; 128 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
68 hppa) export ARCH="parisc";;
69 mips) export ARCH="mips";;
70 *) export ARCH="${ARCH}";;
71 esac 129esac
72}
73 130
74# set's ARCH back to what portage expects 131# @FUNCTION: set_arch_to_kernel
75set_arch_to_portage() { 132# @DESCRIPTION:
76 export ARCH="${PORTAGE_ARCH}" 133# Set the env ARCH to match what the kernel expects.
77} 134set_arch_to_kernel() { export ARCH=$(tc-arch-kernel); }
135# @FUNCTION: set_arch_to_portage
136# @DESCRIPTION:
137# Set the env ARCH to match what portage expects.
138set_arch_to_portage() { export ARCH=$(tc-arch); }
78 139
79
80#
81# qeinfo "Message" 140# qeinfo "Message"
82# ------------------- 141# -------------------
83# qeinfo is a queit einfo call when EBUILD_PHASE 142# qeinfo is a quiet einfo call when EBUILD_PHASE
84# should not have visible output. 143# should not have visible output.
85# 144qout() {
86qeinfo() {
87 local outputmsg 145 local outputmsg type
146 type=${1}
147 shift
88 outputmsg="${@}" 148 outputmsg="${@}"
89 case "${EBUILD_PHASE}" in 149 case "${EBUILD_PHASE}" in
90 depend) unset outputmsg;; 150 depend) unset outputmsg;;
91 clean) unset outputmsg;; 151 clean) unset outputmsg;;
92 preinst) unset outputmsg;; 152 preinst) unset outputmsg;;
93 esac 153 esac
94 [ -n "${outputmsg}" ] && einfo "${outputmsg}" 154 [ -n "${outputmsg}" ] && ${type} "${outputmsg}"
95} 155}
96 156
97qeerror() { 157qeinfo() { qout einfo "${@}" ; }
98 local outputmsg 158qeerror() { qout eerror "${@}" ; }
99 outputmsg="${@}"
100 case "${EBUILD_PHASE}" in
101 depend) unset outputmsg;;
102 clean) unset outputmsg;;
103 preinst) unset outputmsg;;
104 esac
105 [ -n "${outputmsg}" ] && einfo "${outputmsg}"
106}
107
108
109 159
110# File Functions 160# File Functions
111# --------------------------------------- 161# ---------------------------------------
112 162
113# getfilevar accepts 2 vars as follows: 163# @FUNCTION: getfilevar
114# getfilevar <VARIABLE> <CONFIGFILE> 164# @USAGE: variable configfile
115 165# @RETURN: the value of the variable
166# @DESCRIPTION:
167# It detects the value of the variable defined in the file configfile. This is
168# done by including the configfile, and printing the variable with Make.
169# It WILL break if your makefile has missing dependencies!
116getfilevar() { 170getfilevar() {
117local ERROR workingdir basefname basedname xarch 171local ERROR basefname basedname myARCH="${ARCH}"
118 ERROR=0 172 ERROR=0
119 173
120 [ -z "${1}" ] && ERROR=1 174 [ -z "${1}" ] && ERROR=1
121 [ ! -f "${2}" ] && ERROR=1 175 [ ! -f "${2}" ] && ERROR=1
122 176
123 if [ "${ERROR}" = 1 ] 177 if [ "${ERROR}" = 1 ]
124 then 178 then
125 ebeep
126 echo -e "\n" 179 echo -e "\n"
127 eerror "getfilevar requires 2 variables, with the second a valid file." 180 eerror "getfilevar requires 2 variables, with the second a valid file."
128 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 181 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
129 else 182 else
130 workingdir=${PWD}
131 basefname=$(basename ${2}) 183 basefname="$(basename ${2})"
132 basedname=$(dirname ${2}) 184 basedname="$(dirname ${2})"
133 xarch=${ARCH}
134 unset ARCH 185 unset ARCH
135
136 cd ${basedname}
137 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
138 make -f - e 2>/dev/null
139 cd ${workingdir}
140
141 ARCH=${xarch}
142 fi
143}
144 186
187 echo -e "e:\\n\\t@echo \$(${1})\\ninclude ${basefname}" | \
188 make -C "${basedname}" M="${S}" ${BUILD_FIXES} -s -f - 2>/dev/null
189
190 ARCH=${myARCH}
191 fi
192}
193
194# @FUNCTION: getfilevar_noexec
195# @USAGE: variable configfile
196# @RETURN: the value of the variable
197# @DESCRIPTION:
198# It detects the value of the variable defined in the file configfile.
199# This is done with sed matching an expression only. If the variable is defined,
200# you will run into problems. See getfilevar for those cases.
201getfilevar_noexec() {
202 local ERROR basefname basedname mycat myARCH="${ARCH}"
203 ERROR=0
204 mycat='cat'
205
206 [ -z "${1}" ] && ERROR=1
207 [ ! -f "${2}" ] && ERROR=1
208 [ "${2%.gz}" != "${2}" ] && mycat='zcat'
209
210 if [ "${ERROR}" = 1 ]
211 then
212 echo -e "\n"
213 eerror "getfilevar_noexec requires 2 variables, with the second a valid file."
214 eerror " getfilevar_noexec <VARIABLE> <CONFIGFILE>"
215 else
216 ${mycat} "${2}" | \
217 sed -n \
218 -e "/^[[:space:]]*${1}[[:space:]]*=[[:space:]]*\(.*\)\$/{
219 s,^[^=]*[[:space:]]*=[[:space:]]*,,g ;
220 s,[[:space:]]*\$,,g ;
221 p
222 }"
223 fi
224}
225
226
227# @FUNCTION: linux_config_src_exists
228# @RETURN: true or false
229# @DESCRIPTION:
230# It returns true if .config exists in a build directory otherwise false
231linux_config_src_exists() {
232 [ -s "${KV_OUT_DIR}/.config" ]
233}
234
235# @FUNCTION: linux_config_bin_exists
236# @RETURN: true or false
237# @DESCRIPTION:
238# It returns true if .config exists in /proc, otherwise false
239linux_config_bin_exists() {
240 [ -s "/proc/config.gz" ]
241}
242
243# @FUNCTION: linux_config_exists
244# @RETURN: true or false
245# @DESCRIPTION:
246# It returns true if .config exists otherwise false
247#
248# This function MUST be checked before using any of the linux_chkconfig_*
249# functions.
250linux_config_exists() {
251 linux_config_src_exists || linux_config_bin_exists
252}
253
254# @FUNCTION: require_configured_kernel
255# @DESCRIPTION:
256# This function verifies that the current kernel is configured (it checks against the existence of .config)
257# otherwise it dies.
258require_configured_kernel() {
259 if ! linux_config_src_exists; then
260 qeerror "Could not find a usable .config in the kernel source directory."
261 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
262 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
263 qeerror "it points to the necessary object directory so that it might find .config."
264 die "Kernel not configured; no .config found in ${KV_OUT_DIR}"
265 fi
266}
267
268# @FUNCTION: linux_chkconfig_present
269# @USAGE: option
270# @RETURN: true or false
271# @DESCRIPTION:
272# It checks that CONFIG_<option>=y or CONFIG_<option>=m is present in the current kernel .config
273# If linux_config_exists returns false, the results of this are UNDEFINED. You
274# MUST call linux_config_exists first.
145linux_chkconfig_present() { 275linux_chkconfig_present() {
146local RESULT 276local RESULT
277 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
278 local config
279 config="${KV_OUT_DIR}/.config"
280 [ ! -f "${config}" ] && config="/proc/config.gz"
147 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 281 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
148 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1 282 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1
149} 283}
150 284
285# @FUNCTION: linux_chkconfig_module
286# @USAGE: option
287# @RETURN: true or false
288# @DESCRIPTION:
289# It checks that CONFIG_<option>=m is present in the current kernel .config
290# If linux_config_exists returns false, the results of this are UNDEFINED. You
291# MUST call linux_config_exists first.
151linux_chkconfig_module() { 292linux_chkconfig_module() {
152local RESULT 293local RESULT
294 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
295 local config
296 config="${KV_OUT_DIR}/.config"
297 [ ! -f "${config}" ] && config="/proc/config.gz"
153 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 298 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
154 [ "${RESULT}" = "m" ] && return 0 || return 1 299 [ "${RESULT}" = "m" ] && return 0 || return 1
155} 300}
156 301
302# @FUNCTION: linux_chkconfig_builtin
303# @USAGE: option
304# @RETURN: true or false
305# @DESCRIPTION:
306# It checks that CONFIG_<option>=y is present in the current kernel .config
307# If linux_config_exists returns false, the results of this are UNDEFINED. You
308# MUST call linux_config_exists first.
157linux_chkconfig_builtin() { 309linux_chkconfig_builtin() {
158local RESULT 310local RESULT
311 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
312 local config
313 config="${KV_OUT_DIR}/.config"
314 [ ! -f "${config}" ] && config="/proc/config.gz"
159 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 315 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
160 [ "${RESULT}" = "y" ] && return 0 || return 1 316 [ "${RESULT}" = "y" ] && return 0 || return 1
161} 317}
162 318
319# @FUNCTION: linux_chkconfig_string
320# @USAGE: option
321# @RETURN: CONFIG_<option>
322# @DESCRIPTION:
323# It prints the CONFIG_<option> value of the current kernel .config (it requires a configured kernel).
324# If linux_config_exists returns false, the results of this are UNDEFINED. You
325# MUST call linux_config_exists first.
163linux_chkconfig_string() { 326linux_chkconfig_string() {
327 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
328 local config
329 config="${KV_OUT_DIR}/.config"
330 [ ! -f "${config}" ] && config="/proc/config.gz"
164 getfilevar "CONFIG_${1}" "${KV_OUT_DIR}/.config" 331 getfilevar_noexec "CONFIG_${1}" "${config}"
165} 332}
166 333
167# Versioning Functions 334# Versioning Functions
168# --------------------------------------- 335# ---------------------------------------
169 336
170# kernel_is returns true when the version is the same as the passed version 337# @FUNCTION: kernel_is
338# @USAGE: [-lt -gt -le -ge -eq] major_number [minor_number patch_number]
339# @RETURN: true or false
340# @DESCRIPTION:
341# It returns true when the current kernel version satisfies the comparison against the passed version.
342# -eq is the default comparison.
171# 343#
344# @CODE
172# For Example where KV = 2.6.9 345# For Example where KV = 2.6.9
173# kernel_is 2 4 returns false 346# kernel_is 2 4 returns false
174# kernel_is 2 returns true 347# kernel_is 2 returns true
175# kernel_is 2 6 returns true 348# kernel_is 2 6 returns true
176# kernel_is 2 6 8 returns false 349# kernel_is 2 6 8 returns false
177# kernel_is 2 6 9 returns true 350# kernel_is 2 6 9 returns true
178# 351# @CODE
352
179# got the jist yet? 353# got the jist yet?
180 354
181kernel_is() { 355kernel_is() {
182 # if we haven't determined the version yet, we need too. 356 # if we haven't determined the version yet, we need to.
183 get_version; 357 get_version
358 local operator test value x=0 y=0 z=0
359
360 case ${1} in
361 -lt|lt) operator="-lt"; shift;;
362 -gt|gt) operator="-gt"; shift;;
363 -le|le) operator="-le"; shift;;
364 -ge|ge) operator="-ge"; shift;;
365 -eq|eq) operator="-eq"; shift;;
366 *) operator="-eq";;
367 esac
368
369 for x in ${@}; do
370 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
371 value="${value}${x}"
372 z=$((${z} + 1))
373
374 case ${z} in
375 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
376 test="${test}${KV_MAJOR}";;
377 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
378 test="${test}${KV_MINOR}";;
379 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
380 test="${test}${KV_PATCH}";;
381 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
382 esac
383 done
184 384
185 local RESULT operator value test 385 [ ${test} ${operator} ${value} ] && return 0 || return 1
186 RESULT=0
187
188 operator="-eq"
189 if [ "${1}" == "lt" ]
190 then
191 operator="-lt"
192 shift
193 elif [ "${1}" == "gt" ]
194 then
195 operator="-gt"
196 shift
197 elif [ "${1}" == "le" ]
198 then
199 operator="-le"
200 shift
201 elif [ "${1}" == "ge" ]
202 then
203 operator="-ge"
204 shift
205 fi
206
207 if [ -n "${1}" ]
208 then
209 [ ${KV_MAJOR} ${operator} ${1} ] || RESULT=1
210 fi
211 if [ -n "${2}" ]
212 then
213 [ ${KV_MINOR} ${operator} ${2} -a ${RESULT} -eq 0 ] || RESULT=1
214 fi
215 if [ -n "${3}" ]
216 then
217 [ ${KV_PATCH} ${operator} ${3} -a ${RESULT} -eq 0 ] || RESULT=1
218 fi
219 return ${RESULT}
220} 386}
221 387
388get_localversion() {
389 local lv_list i x
390
391 # ignore files with ~ in it.
392 for i in $(ls ${1}/localversion* 2>/dev/null); do
393 [[ -n ${i//*~*} ]] && lv_list="${lv_list} ${i}"
394 done
395
396 for i in ${lv_list}; do
397 x="${x}$(<${i})"
398 done
399 x=${x/ /}
400 echo ${x}
401}
402
403# internal variable, so we know to only print the warning once
404get_version_warning_done=
405
406# @FUNCTION: get_version
407# @DESCRIPTION:
408# It gets the version of the kernel inside KERNEL_DIR and populates the KV_FULL variable
409# (if KV_FULL is already set it does nothing).
410#
411# The kernel version variables (KV_MAJOR, KV_MINOR, KV_PATCH, KV_EXTRA and KV_LOCAL) are also set.
412#
413# The KV_DIR is set using the KERNEL_DIR env var, the KV_DIR_OUT is set using a valid
414# KBUILD_OUTPUT (in a decreasing priority list, we look for the env var, makefile var or the
415# symlink /lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build).
222get_version() { 416get_version() {
223 local kbuild_output 417 local kbuild_output
224 418
225 # no need to execute this twice assuming KV_FULL is populated. 419 # no need to execute this twice assuming KV_FULL is populated.
226 # we can force by unsetting KV_FULL 420 # we can force by unsetting KV_FULL
227 [ -n "${KV_FULL}" ] && return 421 [ -n "${KV_FULL}" ] && return 0
228 422
229 # if we dont know KV_FULL, then we need too. 423 # if we dont know KV_FULL, then we need too.
230 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR 424 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR
231 unset KV_DIR 425 unset KV_DIR
232 426
233 # KV_DIR will contain the full path to the sources directory we should use 427 # KV_DIR will contain the full path to the sources directory we should use
428 [ -z "${get_version_warning_done}" ] && \
234 qeinfo "Determining the location of the kernel source code" 429 qeinfo "Determining the location of the kernel source code"
235 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})" 430 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})"
236 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}" 431 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}"
237 432
238 if [ -z "${KV_DIR}" ] 433 if [ -z "${KV_DIR}" ]
239 then 434 then
435 if [ -z "${get_version_warning_done}" ]; then
436 get_version_warning_done=1
240 qeerror "Unable to find kernel sources at ${KERNEL_DIR}" 437 qeerror "Unable to find kernel sources at ${KERNEL_DIR}"
241 qeinfo "This package requires Linux sources." 438 #qeinfo "This package requires Linux sources."
242 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then 439 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then
243 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, " 440 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, "
244 qeinfo "(or the kernel you wish to build against)." 441 qeinfo "(or the kernel you wish to build against)."
245 qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location" 442 qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location"
246 else 443 else
247 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against." 444 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against."
248 fi 445 fi
249 die "Cannot locate Linux sources at ${KERNEL_DIR}"
250 fi 446 fi
447 return 1
448 fi
251 449
450 if [ -z "${get_version_warning_done}" ]; then
252 qeinfo "Found kernel source directory:" 451 qeinfo "Found kernel source directory:"
253 qeinfo " ${KV_DIR}" 452 qeinfo " ${KV_DIR}"
453 fi
254 454
255 if [ ! -s "${KV_DIR}/Makefile" ] 455 if [ ! -s "${KV_DIR}/Makefile" ]
256 then 456 then
457 if [ -z "${get_version_warning_done}" ]; then
458 get_version_warning_done=1
257 qeerror "Could not find a Makefile in the kernel source directory." 459 qeerror "Could not find a Makefile in the kernel source directory."
258 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources" 460 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources"
259 die "Makefile not found in ${KV_DIR}"
260 fi 461 fi
261 462 return 1
463 fi
464
262 # OK so now we know our sources directory, but they might be using 465 # OK so now we know our sources directory, but they might be using
263 # KBUILD_OUTPUT, and we need this for .config and localversions-* 466 # KBUILD_OUTPUT, and we need this for .config and localversions-*
264 # so we better find it eh? 467 # so we better find it eh?
265 # do we pass KBUILD_OUTPUT on the CLI? 468 # do we pass KBUILD_OUTPUT on the CLI?
266 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}" 469 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
267 470
268 # And if we didn't pass it, we can take a nosey in the Makefile 471 # And if we didn't pass it, we can take a nosey in the Makefile
269 kbuild_output="$(getfilevar KBUILD_OUTPUT ${KV_DIR}/Makefile)" 472 kbuild_output="$(getfilevar_noexec KBUILD_OUTPUT ${KV_DIR}/Makefile)"
270 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}" 473 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
271 474
272 # And contrary to existing functions I feel we shouldn't trust the 475 # And contrary to existing functions I feel we shouldn't trust the
273 # directory name to find version information as this seems insane. 476 # directory name to find version information as this seems insane.
274 # so we parse ${KV_DIR}/Makefile 477 # so we parse ${KV_DIR}/Makefile
275 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)" 478 KV_MAJOR="$(getfilevar_noexec VERSION ${KV_DIR}/Makefile)"
276 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)" 479 KV_MINOR="$(getfilevar_noexec PATCHLEVEL ${KV_DIR}/Makefile)"
277 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)" 480 KV_PATCH="$(getfilevar_noexec SUBLEVEL ${KV_DIR}/Makefile)"
278 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)" 481 KV_EXTRA="$(getfilevar_noexec EXTRAVERSION ${KV_DIR}/Makefile)"
279 482
280 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ] 483 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
281 then 484 then
485 if [ -z "${get_version_warning_done}" ]; then
486 get_version_warning_done=1
282 qeerror "Could not detect kernel version." 487 qeerror "Could not detect kernel version."
283 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources" 488 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
284 die "Could not parse version info from ${KV_DIR}/Makefile"
285 fi 489 fi
286 490 return 1
491 fi
492
287 # and in newer versions we can also pull LOCALVERSION if it is set. 493 # and in newer versions we can also pull LOCALVERSION if it is set.
288 # but before we do this, we need to find if we use a different object directory. 494 # but before we do this, we need to find if we use a different object directory.
289 # This *WILL* break if the user is using localversions, but we assume it was 495 # This *WILL* break if the user is using localversions, but we assume it was
290 # caught before this if they are. 496 # caught before this if they are.
291 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}" == "$(uname -r)" ] && \ 497 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}" == "$(uname -r)" ] && \
292 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}/build}" 498 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build}"
293 499
294 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})" 500 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})"
295 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}" 501 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}"
296 if [ -n "${KV_OUT_DIR}" ]; 502 if [ -n "${KV_OUT_DIR}" ];
297 then 503 then
298 qeinfo "Found kernel object directory:" 504 qeinfo "Found kernel object directory:"
299 qeinfo " ${KV_OUT_DIR}" 505 qeinfo " ${KV_OUT_DIR}"
300 506
301 KV_LOCAL="$(cat ${KV_OUT_DIR}/localversion* 2>/dev/null)" 507 KV_LOCAL="$(get_localversion ${KV_OUT_DIR})"
302 fi 508 fi
303 # and if we STILL haven't got it, then we better just set it to KV_DIR 509 # and if we STILL have not got it, then we better just set it to KV_DIR
304 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}" 510 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}"
305 511
306 KV_LOCAL="${KV_LOCAL}$(cat ${KV_DIR}/localversion* 2>/dev/null)" 512 KV_LOCAL="${KV_LOCAL}$(get_localversion ${KV_DIR})"
513 if linux_config_exists; then
307 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)" 514 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)"
308 KV_LOCAL="${KV_LOCAL//\"/}" 515 KV_LOCAL="${KV_LOCAL//\"/}"
309 516
517 # For things like git that can append extra stuff:
518 [ -e ${KV_DIR}/scripts/setlocalversion ] &&
519 linux_chkconfig_builtin LOCALVERSION_AUTO &&
520 KV_LOCAL="${KV_LOCAL}$(sh ${KV_DIR}/scripts/setlocalversion ${KV_DIR})"
521 fi
522
310 # And we should set KV_FULL to the full expanded version 523 # And we should set KV_FULL to the full expanded version
311 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}" 524 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}"
312 525
313 qeinfo "Found sources for kernel version:" 526 qeinfo "Found sources for kernel version:"
314 qeinfo " ${KV_FULL}" 527 qeinfo " ${KV_FULL}"
315
316 if [ ! -s "${KV_OUT_DIR}/.config" ]
317 then
318 qeerror "Could not find a usable .config in the kernel source directory."
319 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
320 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
321 qeerror "it points to the necessary object directory so that it might find .config."
322 die ".config not found in ${KV_OUT_DIR}"
323 fi
324}
325 528
529 return 0
530}
326 531
532# @FUNCTION: get_running_version
533# @DESCRIPTION:
534# It gets the version of the current running kernel and the result is the same as get_version() if the
535# function can find the sources.
536get_running_version() {
537 KV_FULL=$(uname -r)
538
539 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then
540 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source)
541 unset KV_FULL
542 get_version
543 return $?
544 elif [[ -f ${ROOT}/lib/modules/${KV_FULL}/build/Makefile ]]; then
545 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/build)
546 unset KV_FULL
547 get_version
548 return $?
549 else
550 KV_MAJOR=$(get_version_component_range 1 ${KV_FULL})
551 KV_MINOR=$(get_version_component_range 2 ${KV_FULL})
552 KV_PATCH=$(get_version_component_range 3- ${KV_FULL})
553 KV_PATCH=${KV_PATCH//-*}
554 [[ -n ${KV_FULL#*-} ]] && [[ -n ${KV_FULL//${KV_FULL#*-}} ]] \
555 && KV_EXTRA="-${KV_FULL#*-}"
556 fi
557 return 0
558}
559
560# This next function is named with the eclass prefix to avoid conflicts with
561# some old versionator-like eclass functions.
562
563# @FUNCTION: linux-info_get_any_version
564# @DESCRIPTION:
565# This attempts to find the version of the sources, and otherwise falls back to
566# the version of the running kernel.
567linux-info_get_any_version() {
568 get_version
569 if [[ $? -ne 0 ]]; then
570 ewarn "Unable to calculate Linux Kernel version for build, attempting to use running version"
571 get_running_version
572 fi
573}
327 574
328 575
329# ebuild check functions 576# ebuild check functions
330# --------------------------------------- 577# ---------------------------------------
331 578
579# @FUNCTION: check_kernel_built
580# @DESCRIPTION:
581# This function verifies that the current kernel sources have been already prepared otherwise it dies.
332check_kernel_built() { 582check_kernel_built() {
333 # if we haven't determined the version yet, we need too. 583 # if we haven't determined the version yet, we need to
584 require_configured_kernel
334 get_version; 585 get_version
335 586
336 if [ ! -f "${KV_OUT_DIR}/System.map" ] 587 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ]
337 then 588 then
338 eerror "These sources have not yet been compiled." 589 eerror "These sources have not yet been prepared."
339 eerror "We cannot build against an uncompiled tree." 590 eerror "We cannot build against an unprepared tree."
340 eerror "To resolve this, please type the following:" 591 eerror "To resolve this, please type the following:"
341 eerror 592 eerror
342 eerror "# cd ${KV_DIR}" 593 eerror "# cd ${KV_DIR}"
343 eerror "# make oldconfig" 594 eerror "# make oldconfig"
344 eerror "# make bzImage modules modules_install" 595 eerror "# make modules_prepare"
345 eerror 596 eerror
346 eerror "Then please try merging this module again." 597 eerror "Then please try merging this module again."
347 die "Kernel sources need compiling first" 598 die "Kernel sources need compiling first"
348 fi 599 fi
349} 600}
350 601
602# @FUNCTION: check_modules_supported
603# @DESCRIPTION:
604# This function verifies that the current kernel support modules (it checks CONFIG_MODULES=y) otherwise it dies.
351check_modules_supported() { 605check_modules_supported() {
352 # if we haven't determined the version yet, we need too. 606 # if we haven't determined the version yet, we need too.
607 require_configured_kernel
353 get_version; 608 get_version
354 609
355 if ! linux_chkconfig_builtin "MODULES" 610 if ! linux_chkconfig_builtin "MODULES"
356 then 611 then
357 eerror "These sources do not support loading external modules." 612 eerror "These sources do not support loading external modules."
358 eerror "to be able to use this module please enable \"Loadable modules support\"" 613 eerror "to be able to use this module please enable \"Loadable modules support\""
359 eerror "in your kernel, recompile and then try merging this module again." 614 eerror "in your kernel, recompile and then try merging this module again."
360 die "No support for external modules in ${KV_FULL} config" 615 die "No support for external modules in ${KV_FULL} config"
361 fi 616 fi
362} 617}
363 618
619# @FUNCTION: check_extra_config
620# @DESCRIPTION:
621# It checks the kernel config options specified by CONFIG_CHECK. It dies only when a required config option (i.e.
622# the prefix ~ is not used) doesn't satisfy the directive.
364check_extra_config() { 623check_extra_config() {
365local config negate error local_error 624 local config negate die error reworkmodulenames
625 local soft_errors_count=0 hard_errors_count=0 config_required=0
366 626
367 # if we haven't determined the version yet, we need too. 627 # if we haven't determined the version yet, we need to
368 get_version; 628 get_version
369 629
370 einfo "Checking for suitable kernel configuration options" 630 # Determine if we really need a .config. The only time when we don't need
631 # one is when all of the CONFIG_CHECK options are prefixed with "~".
371 for config in ${CONFIG_CHECK} 632 for config in ${CONFIG_CHECK}
372 do 633 do
373 negate="${config:0:1}" 634 if [[ "${config:0:1}" != "~" ]]; then
374 if [ "${negate}" == "!" ]; 635 config_required=1
375 then 636 break
637 fi
638 done
639
640 if [[ ${config_required} == 0 ]]; then
641 # In the case where we don't require a .config, we can now bail out
642 # if the user has no .config as there is nothing to do. Otherwise
643 # code later will cause a failure due to missing .config.
644 if ! linux_config_exists; then
645 ewarn "Unable to check for the following kernel config options due"
646 ewarn "to absence of any configured kernel sources or compiled"
647 ewarn "config:"
648 for config in ${CONFIG_CHECK}; do
649 ewarn " - ${config#\~}"
650 done
651 ewarn "You're on your own to make sure they are set if needed."
652 return 0
653 fi
654 else
655 [ -n "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
656 fi
657
658 einfo "Checking for suitable kernel configuration options..."
659
660 for config in ${CONFIG_CHECK}
661 do
662 # if we specify any fatal, ensure we honor them
663 die=1
664 error=0
665 negate=0
666 reworkmodulenames=0
667
668 if [[ ${config:0:1} == "~" ]]; then
669 die=0
376 config="${config:1}" 670 config=${config:1}
671 elif [[ ${config:0:1} == "@" ]]; then
672 die=0
673 reworkmodulenames=1
674 config=${config:1}
675 fi
676 if [[ ${config:0:1} == "!" ]]; then
677 negate=1
678 config=${config:1}
679 fi
680
681 if [[ ${negate} == 1 ]]; then
682 linux_chkconfig_present ${config} && error=2
683 elif [[ ${reworkmodulenames} == 1 ]]; then
684 local temp_config="${config//*:}" i n
685 config="${config//:*}"
377 if linux_chkconfig_present ${config} 686 if linux_chkconfig_present ${config}; then
378 then 687 for i in ${MODULE_NAMES}; do
688 n="${i//${temp_config}}"
689 [[ -z ${n//\(*} ]] && \
690 MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}"
691 done
692 error=2
693 fi
694 else
695 linux_chkconfig_present ${config} || error=1
696 fi
697
698 if [[ ${error} > 0 ]]; then
699 local report_func="eerror" local_error
700 local_error="ERROR_${config}"
701 local_error="${!local_error}"
702
703 if [[ -z "${local_error}" ]]; then
704 # using old, deprecated format.
379 local_error="${config}_ERROR" 705 local_error="${config}_ERROR"
380 local_error="${!local_error}" 706 local_error="${!local_error}"
381 [ -n "${local_error}" ] && eerror " ${local_error}" || \
382 eerror " CONFIG_${config}:\tshould not be set in the kernel configuration, but it is."
383 error=1
384 fi 707 fi
385 else 708 if [[ ${die} == 0 && -z "${local_error}" ]]; then
386 if ! linux_chkconfig_present ${config} 709 #soft errors can be warnings
387 then
388 local_error="${config}_ERROR" 710 local_error="WARNING_${config}"
389 local_error="${!local_error}" 711 local_error="${!local_error}"
390 [ -n "${local_error}" ] && eerror " ${local_error}" || \ 712 if [[ -n "${local_error}" ]] ; then
391 eerror " CONFIG_${config}:\tshould be set in the kernel configuration, but isn't" 713 report_func="ewarn"
392 error=1 714 fi
393 fi 715 fi
716
717 if [[ -z "${local_error}" ]]; then
718 [[ ${error} == 1 ]] \
719 && local_error="is not set when it should be." \
720 || local_error="should not be set. But it is."
721 local_error="CONFIG_${config}:\t ${local_error}"
722 fi
723 if [[ ${die} == 0 ]]; then
724 ${report_func} " ${local_error}"
725 soft_errors_count=$[soft_errors_count + 1]
726 else
727 ${report_func} " ${local_error}"
728 hard_errors_count=$[hard_errors_count + 1]
729 fi
394 fi 730 fi
395 done 731 done
396 732
397 if [ -n "${error}" ] ; 733 if [[ ${hard_errors_count} > 0 ]]; then
398 then
399 eerror "Please check to make sure these options are set correctly." 734 eerror "Please check to make sure these options are set correctly."
735 eerror "Failure to do so may cause unexpected problems."
400 eerror "Once you have satisfied these options, please try merging" 736 eerror "Once you have satisfied these options, please try merging"
401 eerror "this package again." 737 eerror "this package again."
402 die "Incorrect kernel configuration options" 738 die "Incorrect kernel configuration options"
739 elif [[ ${soft_errors_count} > 0 ]]; then
740 ewarn "Please check to make sure these options are set correctly."
741 ewarn "Failure to do so may cause unexpected problems."
742 else
743 eend 0
403 fi 744 fi
404} 745}
405 746
406check_zlibinflate() { 747check_zlibinflate() {
407 # if we haven't determined the version yet, we need too. 748 # if we haven't determined the version yet, we need to
749 require_configured_kernel
408 get_version; 750 get_version
409 751
410 # although I restructured this code - I really really really dont support it! 752 # although I restructured this code - I really really really dont support it!
411 753
412 # bug #27882 - zlib routines are only linked into the kernel 754 # bug #27882 - zlib routines are only linked into the kernel
413 # if something compiled into the kernel calls them 755 # if something compiled into the kernel calls them
414 # 756 #
415 # plus, for the cloop module, it appears that there's no way 757 # plus, for the cloop module, it appears that there's no way
416 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS 758 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS
417 # is on 759 # is on
418 760
419local INFLATE 761 local INFLATE
420local DEFLATE 762 local DEFLATE
421 763
422 einfo "Determining the usability of ZLIB_INFLATE support in your kernel" 764 einfo "Determining the usability of ZLIB_INFLATE support in your kernel"
423 765
424 ebegin "checking ZLIB_INFLATE" 766 ebegin "checking ZLIB_INFLATE"
425 getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config 767 linux_chkconfig_builtin CONFIG_ZLIB_INFLATE
426 eend $? 768 eend $?
427 [ "$?" != 0 ] && die 769 [ "$?" != 0 ] && die
428 770
429 ebegin "checking ZLIB_DEFLATE" 771 ebegin "checking ZLIB_DEFLATE"
430 getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config 772 linux_chkconfig_builtin CONFIG_ZLIB_DEFLATE
431 eend $? 773 eend $?
432 [ "$?" != 0 ] && die 774 [ "$?" != 0 ] && die
433 775
434
435 local LINENO_START 776 local LINENO_START
436 local LINENO_END 777 local LINENO_END
437 local SYMBOLS 778 local SYMBOLS
438 local x 779 local x
439 780
440 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)" 781 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)"
441 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)" 782 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)"
442 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START )) 783 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START ))
443 (( LINENO_END = $LINENO_END - 1 )) 784 (( LINENO_END = $LINENO_END - 1 ))
444 SYMBOLS="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')" 785 SYMBOLS="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')"
450 # we have a winner! 791 # we have a winner!
451 einfo "${x} ensures zlib is linked into your kernel - excellent" 792 einfo "${x} ensures zlib is linked into your kernel - excellent"
452 return 0 793 return 0
453 fi 794 fi
454 done 795 done
455 796
456 eerror 797 eerror
457 eerror "This kernel module requires ZLIB library support." 798 eerror "This kernel module requires ZLIB library support."
458 eerror "You have enabled zlib support in your kernel, but haven't enabled" 799 eerror "You have enabled zlib support in your kernel, but haven't enabled"
459 eerror "enabled any option that will ensure that zlib is linked into your" 800 eerror "enabled any option that will ensure that zlib is linked into your"
460 eerror "kernel." 801 eerror "kernel."
474} 815}
475 816
476################################ 817################################
477# Default pkg_setup 818# Default pkg_setup
478# Also used when inheriting linux-mod to force a get_version call 819# Also used when inheriting linux-mod to force a get_version call
479 820# @FUNCTION: linux-info_pkg_setup
821# @DESCRIPTION:
822# Force a get_version() call when inherited from linux-mod.eclass and then check if the kernel is configured
823# to support the options specified in CONFIG_CHECK (if not null)
480linux-info_pkg_setup() { 824linux-info_pkg_setup() {
481 get_version; 825 linux-info_get_any_version
826
827 if kernel_is 2 4; then
828 if [ "$( gcc-major-version )" -eq "4" ] ; then
829 echo
830 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with"
831 ewarn "linux-2.4 (or modules building against a linux-2.4 kernel)!"
832 echo
833 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
834 ewarn "newer kernel that supports gcc-4."
835 echo
836 ewarn "Also be aware that bugreports about gcc-4 not working"
837 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
838 echo
839 epause 10
840 fi
841 fi
842
482 [ -n "${CONFIG_CHECK}" ] && check_extra_config; 843 [ -n "${CONFIG_CHECK}" ] && check_extra_config;
483} 844}

Legend:
Removed from v.1.12  
changed lines
  Added in v.1.68

  ViewVC Help
Powered by ViewVC 1.1.20